/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"
#include "math.h"
/*Rajesh*/
int npac_store;
int npac_loop;
int npac_rank;
int npac_temp1;
int npac_loop2[200]; /* BOZKUS */
int parse_check = 0;
/*END*/

Node *parse_pass (node)
Node *node;
{
	node = check_pass (node);
	node = trans_pass (node);

	return node;	
}

/* If some argument is a function ==> correct entry and typ */

static find_out_if_some_argument_is_a_function (sublist)
Node *sublist;
{
	Node *sub, *temp;
	char *name;
	T_Entry *entry, *lentry;

	for (LIST_LOOP (sub, sublist, temp))
		if (sub != NN  /* in intrin_cmplx we are setting one to NN */
		&& sub->Subscript.Expr != NN  /* * argument */
		&& sub->Subscript.Expr->com.type == NAME) {
			name = sub->Subscript.Expr->com.str;

			if ((entry = lookup_glo (name)) != TN
			&& IS_explicit (entry)) {
				sub->Subscript.Expr->com.typ = entry->typ;

/* Here we probably would need to delete the lentry but ... */

				lentry = lookup_loc (name);
#ifdef CHECK
				if (lentry == TN)
					SYSERR;
#endif
				lentry->typ->etype = entry->typ->etype;
			}
		}
}

parse_args (funname, funentry, sublist, proc_type)
char *funname;
T_Entry *funentry;
Node *sublist;
int proc_type;
{
	Node *sub, *temp, *new, *extra;
	Interf *interf = (Interf*) 0, *ref_interf;
	T_Entry *entry;
	int typecheck;
	Etype *dumtype, *acttype;
	int found_rank_error = 0;

	find_out_if_some_argument_is_a_function (sublist);

	if (funentry != TN)
		typecheck = !IS_no_checking (funentry);
	else
		typecheck = 1;

	if (funentry != TN
	&& (interf = funentry->interf) != (Interf*) 0
	&& IS_explicit (funentry)) {
		int i, num, nargs = interf->nargs;
		char *argname;

		num = 1;
		for (LIST_LOOP (sub, sublist, temp)) {
			if (nargs <= num) {
				break;
			}

			if (sub != NN) {
				if (typecheck
				&& etype_ne (acttype = sub->Subscript.Expr->com.typ->etype
			                ,dumtype = interf->entry[num]->typ->etype)) {
					sprintf (serr
					, "argument %d of procedure '%s' must be %s, is %s"
					, num, funname
					, etype_name (dumtype), etype_name (acttype));
					fatal (serr);
				}

				if (IS_assumed_shape (interf->entry[num])
				&& SHAPE_IS_NULL (sub->Subscript.Expr->com.typ->shape)) {
					sprintf (serr, "argument %d of procedure '%s' must be array valued"
					, num, funname);
					fatal (serr);
					found_rank_error = 1;
				}
			}

			num++;
		}

		num = 1;
		for (LIST_LOOP (sub, sublist, temp)) {
			entry = interf->entry[num];

			if (sub == NN) {  /* is a missing optional */
				extra = Node_0;
				extra->com.typ = typ_malloc ();
				extra->com.typ->etype = entry->typ->etype;
				temp->lst.value = make_Subscript (extra, NN, NN);

				if (IS_optional (entry)) {
					extra= make_LogicalConstant (".FALSE.");
					extra->com.typ = typ_malloc ();
					extra->com.typ->etype = Etype_LOGICAL_0;
					temp = list_add (temp, make_Subscript (extra, NN, NN));
				}

				if (IS_assumed_shape (entry)) {
					extra = Node_0;
					extra->com.typ = typ_malloc ();
					extra->com.typ->etype = Etype_INTEGER_0;
					temp = list_add (temp, make_Subscript (extra, NN, NN));
				}

				num++;
				continue;
			}

			fun_subscript_output (sub, funentry, 0, entry);

			if (IS_optional (entry)) {
				extra = make_LogicalConstant (".TRUE.");
				extra->com.typ = typ_malloc ();
				extra->com.typ->etype = Etype_LOGICAL_0;
				LIST_ADD (new, make_Subscript (extra, NN, NN), temp);
			}

			if (IS_assumed_shape (entry)) {
				char *name;

				interf_set_assumed (sub);

				if ((name = sub->Subscript.Expr->com.str) == (char*) 0) {
					if (sub->Subscript.Expr->com.type == DUM_ARR_CONS) {
						name = sub->Subscript.Expr->DumArrCons.Expr->com.str;
					}
					else {
						sprintf (serr, "implement, type = %s"
						, node_Symbol (sub->Subscript.Expr->com.type));
						syserr (serr);
					}
				}

				if (found_rank_error)
					extra = make_Name ("ERROR");
				else
					extra = make_Name (desc_name (name));

				extra->com.typ = typ_malloc ();
				extra->com.typ->etype = Etype_INTEGER_0;
				LIST_ADD (new, make_Subscript (extra, NN, NN), temp);
			}

			num++;
		}

		if (num < interf->nargs) {
			for (LIST_LOOP (sub, sublist, temp))
				if (LIST_LAST (temp))
					break;

			for (; num < interf->nargs; num++) {
				entry = interf->entry[num];

				if (IS_optional (entry)) {
					extra = Node_0;
					extra->com.typ = typ_malloc ();
					extra->com.typ->etype = entry->typ->etype;
					temp = list_add (temp, make_Subscript (extra, NN, NN));

					extra= make_LogicalConstant (".FALSE.");
					extra->com.typ = typ_malloc ();
					extra->com.typ->etype = Etype_LOGICAL_0;
					temp = list_add (temp, make_Subscript (extra, NN, NN));
				}
				else {
					sprintf (serr
					        , "argument %d of procedure '%s' is not an optional argument"
					        , num, funname);
					fatal (serr);
				}
			}
		}
	}
	else {
		for (LIST_LOOP (sub, sublist, temp)) {
			if (sub == NN)  /* for error recovery */
				goto skip;

			if (sub->Subscript.Eq != NN) {  /* is keyword argument */
				sprintf (serr
				, "need to define interface for '%s' to be able to use keyword arguments"
				, funname);
				fatal (serr);
			}

			fun_subscript_output (sub, funentry, 0, 0);
		}

		ref_interf = interf_from_sublist (funname, sublist);

		if (typecheck ) {
			if (interf != (Interf*) 0) {
				int give_fatal = IS_explicit (funentry);
				interf_check_interf (interf, ref_interf, give_fatal);
			}
			else {
				if (funentry == TN)
					funentry = install_glo (funname, TAB_NAME, 0);

					if (proc_type == FUNCTION_REFERENCE)
						SET_function (funentry);
					else
						SET_subroutine (funentry);
	
				funentry->interf = ref_interf;
			}
		}
	}

skip:

/* adds file and line no to array intrinsics */

	if (IS_array_intrinsic (funentry)) {
		if (flag_externals) {
			extra = make_Name ("file");
			extra->com.typ = typ_malloc ();
			extra->com.typ->etype = Etype_CHARACTER_0;
/* ##BEGIN##,02/23/1992, ZEKI */
/* This is to elinate file name from intrinsic output */
/*			sublist
			= list_add_beg (sublist, make_Subscript (extra, NN, NN), SUBSCRIPT_LIST);
*/
/* ##END## */

			extra = make_Name ("line");
			extra->com.typ = typ_malloc ();
			extra->com.typ->etype = Etype_INTEGER_0;
/* ##BEGIN##,02/23/1992, ZEKI */
/* This is to elinate line name from intrinsic output */
/*			sublist
			= list_add_beg (sublist, make_Subscript (extra, NN, NN), SUBSCRIPT_LIST);
*/
/* ##END## */
		}
		else {
			char *filename = U_malloc (strlen (input_filename) + 3);

			sprintf (filename, "'%s'", input_filename);
			extra = make_Name (filename);
			extra->com.typ = typ_malloc ();
			extra->com.typ->etype = Etype_CHARACTER_0;
/* ##BEGIN##,02/23/1992, ZEKI */
/* This is to elinate file name from intrinsic output */
/*			sublist
			= list_add_beg (sublist, make_Subscript (extra, NN, NN), SUBSCRIPT_LIST); 
*/
/* ##END## */
			extra = make_IntegerConstant (real_zzlineno ());
			extra->com.typ = typ_malloc ();
			extra->com.typ->etype = Etype_INTEGER_0;
/* ##BEGIN##,02/23/1992, ZEKI */
/* This is to elinate line name from intrinsic output */
/*			sublist
			= list_add_beg (sublist, make_Subscript (extra, NN, NN), SUBSCRIPT_LIST);
*/
/* ##END## */

		}
	}
}

Node *parse_CallStmt (root)
Node *root;
{
	char *name = root->CallStmt.Name->com.str;
	T_Entry *entry;
	Node *sublist = root->CallStmt.SubscriptList;

	root->com.str = name;

	entry = lookup_glo (name);

	if (entry != TN && !IS_subroutine (entry) && !IS_common (entry)) {
		char *what;
		T_Entry *over_entry;

		if (IS_over (entry)) {
			over_entry = entry->over->entry [0];
			if (IS_subroutine (over_entry))
				goto skip;
		}
		else
			over_entry = entry;

		if (IS_function (over_entry))
			what = "FUNCTION";
		else
			what = "NOT SUBROUTINE";

		sprintf (serr, "'%s' was previously defined as %s", name, what);

		if (IS_explicit (over_entry)) {
			fatal (serr);

			root = Node_0;  /* error recovery */
			return root;
		}
		else
			warning (serr);
	}

skip:

	sublist = root->CallStmt.SubscriptList = opt_fill_opt (name, entry, sublist);

	if (entry != TN && IS_over (entry)) {
		entry = over_replace (entry, sublist);
		name = root->com.str = root->CallStmt.Name->com.str = entry->orig_name;
	}

    parse_args (name, entry, sublist, CALL_STMT);

	return root;
}

Node *parse_ArraySection (root)
Node *root;
{
	Node *Nname = root->ArraySection.Name;
	Node *sublist = root->ArraySection.SubscriptList;
	T_Entry *entry, *proentry;
	char *name;
        int logic; /*ZEKI*/
        Node *sublist1, *temp1, *sub1;
        char *s1, *s2, *c1, *c2;

	if (root->ArraySection.ArraySection != NN) {  /*!!! char (2)(1:4) type, improve */
		name = root->ArraySection.ArraySection->ArraySection.Name->com.str;
		root->com.typ = root->ArraySection.ArraySection->com.typ;
		root->com.str = name;
		return root;
	}

	name = Nname->com.str;
	root->com.str = name;

/* if in declaration statement do it separately (looking at external and ...) */

	if ((entry = lookup_loc (name)) != TN
	  && entry->typ->shape != (Shape*) 0) {  /* is array */
		if (!se_in_equivalence)
			parse_name (Nname);

		typ_check_subscripts (sublist, name);
                /** BOZKUS */
                root->ArraySection.Org_SubscriptList = 
                      tree_dup(root->ArraySection.SubscriptList); 
              /* this is for debugging */
            /* printf("This is parse_ArraySection %s\n", name);
               sublist1 = list_invert(root->ArraySection.Org_SubscriptList);
               for (LIST_LOOP (sub1, sublist1, temp1)){
                    s1="nil";
                    s2="nil";
                    c1=" ";
                    c2=" ";
                    if(sub1->Subscript.Expr) 
                           s1= sub1->Subscript.Expr->com.str;
                    if(sub1->Subscript.Colon) 
                             c1=":";

                    if(sub1->Subscript.Expr1)
                           s2= sub1->Subscript.Expr1->com.str;
                    if(sub1->Subscript.Colon1) 
                             c2=":";

                    printf("  %s %s %s  %s \n", s1,c1,s2,c2);
		  }
             */
                 /** END **/

		root->com.typ = typ_malloc ();

		if (entry->typ->etype != EN)
			root->com.typ->etype = entry->typ->etype;
		else {
			if (!se_in_equivalence)
				root->com.typ->etype = implicit_get (name);
		}
                
		root->com.typ->shape = shape_Array (name, sublist);

	}
	else {  /* is function */
		Node *code, *temp, *stmt;
		Etype *etype = EN, *loc_etype;
		T_Entry *loc_entry;
		int ret, use_se_intrin = 0;

		if (entry != TN && entry->typ->etype != EN
		&&  entry->typ->etype->type == TYP_CHARACTER) {  /*!!! assume char*9 var ==> var (1:3) */
			root->com.typ = typ_malloc ();
			root->com.typ->etype = entry->typ->etype;
			return root;
		}

		root = make (FUNCTION_REFERENCE);
		root->FunctionReference.Name = Nname;
		root->FunctionReference.Lp = &Lp;
		root->FunctionReference.SubscriptList = sublist = list_invert (sublist);
		root->FunctionReference.Rp = &Rp;

		root->com.str = name;
		root->com.typ = typ_malloc ();

		proentry = lookup_glo (name);

		if (proentry != TN && !IS_function (proentry) && !IS_common (proentry)) {
			char *what;
			T_Entry *over_entry;

			if (IS_over (proentry)) {
				over_entry = proentry->over->entry [0];
				if (IS_function (over_entry))
					goto skip;
			}
			else
				over_entry = proentry;

			if (IS_subroutine (over_entry))
				what = "SUBROUTINE";
			else
				what = "NOT FUNCTION";

			sprintf (serr, "'%s' was previously defined as %s", name, what);

			if (IS_explicit (over_entry)) {
				fatal (serr);

				root = Node_0;  /* error recovery */
				return root;
			}
			else
				warning (serr);
		}

skip:

		if (proentry != TN) {
			if ((IS_explicit (proentry) || IS_intrinsic (proentry))
			&& !IS_over (proentry))  /* overloaded entry doesn't have type */
				etype = proentry->typ->etype;

			if (!intrin_var_args (proentry)) {
				root = parse_FunctionReference (root);

				if (IS_over (proentry)) {
					T_Entry *over_entry = lookup_glo (root->com.str);

					if (over_entry->typ != (Typ*) 0)
						etype = over_entry->typ->etype;
					else
						etype = Etype_INTEGER_0;  /* error recovery: if no over match ... */
				}
			}
			else {  /* works for MAX and MIN */
				etype = sublist->lst.value->Subscript.Expr->com.typ->etype;
			}

			if (IS_f77_intrinsic (proentry))  /* leaves old name */
				root->com.str = root->FunctionReference.Name->com.str = name;

			if (IS_elemental (proentry))
				root->com.typ->shape = shape_Elemental (name, sublist);

/* error checking for types, looks if local declaration is ok with explicit interface */

			if ((etype != EN)
			&& ((loc_entry = lookup_loc (name)) != TN)
			&& etype_ne (etype, loc_entry->typ->etype)
			&& !IS_implicit_type (loc_entry)) {
						sprintf (serr
						, "ambigous type for '%s': from interface %s, from local declaration %s"
						, name, etype_name (etype), etype_name (loc_entry->typ->etype));
						fatal (serr);
					}
		}
		else {
			root = parse_FunctionReference (root); /*sets root->com.typ(str) if over*/
		}


		if (etype == EN) {  /* type not defined by intrinsic or external interface */
			if ((loc_entry = lookup_loc (name)) != TN) { /* if dec as INTEGER FUN */
				etype = loc_entry->typ->etype;

				if (proentry != TN && proentry->typ != (Typ*) 0
				&& etype_ne (etype, proentry->typ->etype)) {
					sprintf (serr
					, "there is an external declaration of %s as %s, locally is declared as %s"
					, name, etype_name (proentry->typ->etype), etype_name (etype));
					warning (serr);
				}
				else {
					install_glo (name, TAB_TYP_ETYPE, etype);
				}
			}
			else {
				etype = implicit_get_for_external (name);
				loc_entry = install_glo (name, TAB_TYP_ETYPE, etype);
				SET_implicit_type (loc_entry);
			}
		}

/* now proentry points to the replaced over, if not f77_intrinsic, and etype is corrent
   or EN if it is an undeclared function */

		proentry = lookup_glo (root->com.str);

		if (proentry->typ == (Typ*) 0) {
			proentry->typ = typ_malloc ();
			proentry->typ->etype = etype;
		}

		if (proentry != TN && IS_compile_time (proentry)) {
			if ((ret = (*proentry->compile_time) (&root)) == 0)
				return root;
			else if (ret == 2) {
				name = root->com.str;
				root->FunctionReference.Name->com.str = name;
				if ((proentry = lookup_glo (root->com.str)) != TN)
					etype = proentry->typ->etype;
				else
					install_glo (name, TAB_TYP_ETYPE, etype);
			}
			else if (ret == 3) {
				use_se_intrin = 1;

				name = root->com.str;
				root->FunctionReference.Name->com.str = name;

				if ((proentry = lookup_glo (name)) == TN) {
					proentry = install_glo (name, TAB_NAME, 0);
					proentry->typ = se_intrin_typ;
                                	etype = se_intrin_typ->etype;
/* ##BEGIN## , 03/15/1992, ZEKI */
/* This part is to mark attr_npac_intrinsic and make all intrinsic
   as subroitene CALL even scalar intrinsic */

                                        SET_npac_intrinsic(proentry); 

/* old COMMENT: For rank zero, means output of intrinsic is not array
   intrinsic will be called as function if you find to change it
   you have to crate a temproary anf put reasult on it */ 


					if (se_intrin_shape->rank) {
						SET_array (proentry);
						SET_assumed_shape (proentry);
					}
/* ##END## */

					SET_assumed_pass (proentry);
					SET_automatic (proentry);
					SET_function (proentry);
				}
				else {
					etype = proentry->typ->etype;
				}
			}
		}

		root->com.typ->etype = etype;

/* declare type of function only for functions with explicit interfaces and that
   are not F77 intriniscs. */

		if (proentry != TN
		&& IS_explicit (proentry)
		&& !IS_f77_intrinsic (proentry)
		&& !IS_array (proentry))
		   decl_intrin_add (mac_etype_name (etype), root->com.str);

		root->FunctionReference.entry = lookup_glo (root->com.str);
/* ZEKI */
                logic=0;
/*                if (proentry!=TN) if (IS_npac_intrinsic(proentry)) logic=1;*/

		if ((proentry != TN && proentry->typ != (Typ*) 0
		&& proentry->typ->shape != (Shape*) 0 && proentry->typ->shape->rank > 0)
		|| (use_se_intrin && se_intrin_shape->rank > 0)
                || logic) {   /* ZEKI */
	 		/* array function, replace by temp and produce call */
			Node *temp, *var;
			T_Entry *tentry;
/* ZEKI */ /* make shape NULL (SN) if output of intrinsic is scalar  
                        if((se_intrin_typ->shape->rank==0)&&logic)
                                  se_intrin_typ->shape=SN;*/
                 
			if (use_se_intrin)
				temp = temp_make (se_intrin_typ, 0, &var);
			else
				temp = temp_make (proentry->typ, 0, &var);

			tentry = lookup_loc (temp->com.str);

			if (use_se_intrin || (IS_assumed_shape (proentry) && tentry != TN)) {
				SET_assumed_pass (tentry);
				desc_put_in_table (tentry);
			}

        /* ZEKI */      /* set output of intrinsic temproray array */         
                        SET_output_of_intrinsic(tentry);

			root->FunctionReference.temp = var;
			stmt = make (DUM_STMT);
			stmt->DumStmt.Stmt = make (CALL_STMT);
			stmt->DumStmt.Code = root;
			
			root = temp;
			root->com.trans = trans_add_stmt_bef (root->com.trans, stmt);
		}
	}

	return root;
}

Node *parse_FunctionReference (root)
Node *root;
{
	char *name = root->FunctionReference.Name->com.str;
	Node *sublist = root->FunctionReference.SubscriptList;
	T_Entry *entry = lookup_glo (name);

	sublist = root->FunctionReference.SubscriptList =
	                              opt_fill_opt (name, entry, sublist);

	if (entry != TN && IS_over (entry)) {
		entry = over_replace (entry, sublist);
		name = root->com.str = root->FunctionReference.Name->com.str = entry->orig_name;
	}

	parse_args (name, entry, sublist, FUNCTION_REFERENCE);

	return root;
}

T_Entry *parse_name (Nname)
Node *Nname;
{
	T_Entry *entry;
	Etype *etype;
	char *name = Nname->com.str;

	if ((entry = lookup_loc (name)) != TN
	&& entry->typ != (Typ*) 0
	&& entry->typ->etype != EN)
		;
	else {  /* set implicit type, and install in table */
		if (scoping_unit [state_level] == UNIT_FUNCTION
		&& !U_strcmp_nocase (name, se_FunctionStmt_name)) {
			if ((entry = lookup_user (name)) == TN) {
				if (se_FunctionStmt_etype != EN) {
					entry = install_loc (name, TAB_TYP_ETYPE, se_FunctionStmt_etype);
				}
				else {
					etype = implicit_get (name);
					entry = install_loc (name, TAB_TYP_ETYPE, etype);
					SET_implicit_type (entry);
				}
			}
		}
		else {
			etype = implicit_get (name);
			entry = install_loc (name, TAB_TYP_ETYPE, etype);
			SET_implicit_type (entry);
		}
	}

	Nname->com.typ = entry->typ;

	return entry;
}

Node *parse_ImpliedDoControl (root)
Node *root;
{
	Node *Nname = root->ImpliedDoControl.Name;

	parse_name (Nname);

	return root;
}

Node *parse_Variable (root)
Node *root;
{
	Node *Nname = root->Variable.Name;
	T_Entry *entry;
	Typ *typ;

	entry = parse_name (Nname);
	typ = entry->typ;

	if (entry != TN && IS_array (entry)) {  /* a <==> a(:) */
		Node *list = ENTRY_SUBLIST (entry);
		Node *newlist = tree_dup (list);
		
		typ_decl_var (newlist); 
		root = make_ArraySection (Nname, newlist);

/*!!! Tue Jul 30 14:42:26 PDT 1991 Next line to fix problem with arr (1: fun ())
      Delete once the general problem arr (f1():f2():f3()) is fixed. */

		shape_Array_just_remove (newlist);
		typ->shape = entry->typ->shape;

		root->com.str = Nname->com.str;
	}
	else {
		root = Nname;
	}

	root->com.typ = typ;

	return root;
}

Node *parse_NamedConstantDef (root)
Node *root;
{
	Node *Nname = root->NamedConstantDef.Name;
	Node *expr = root->NamedConstantDef.Expr;
	T_Entry *entry;
	char *name = Nname->com.str;
	Etype *etype;
	double value;

	if ((entry = lookup_loc (name)) == TN) {
		etype = implicit_get (name);
		entry = install_loc (name, TAB_TYP_ETYPE, etype);
	}
	else if (IS_parameter (entry)) {
		sprintf (serr, "PARAMETER '%s' already defined", entry->orig_name);
		fatal (serr);
		return root;
	}

	if (expr_is_constant (expr, &value) == 0) {
		sprintf (serr, "PARAMETER '%s' set to a non-constant", name);
		fatal (serr);  /* E_5_14_19 */
	}

	SET_parameter (entry);
	ENTRY_VALUE (entry) = expr;

	return root;
}

Node *parse_EntityDecl (root)
Node *root;
{
	Node *Nname = root->EntityDecl.Name;
	Node *opt7 = root->EntityDecl.opt7;
	char *name = Nname->com.str;
	Shape *shape;
	T_Entry *entry;
	Node *sublist;

	root->com.str = name;

	if ((entry = lookup_loc (name)) == TN)
		entry = install_loc (name, TAB_NAME, 0);

/* DIMENSION & COMMON is processed here also */

	if (se_DimensionStmt_in) {
		if (opt7 == NN)
			fatal ("a subscript list is required in a DIMENSION statement");
	}

	if (opt7 != NN && se_AttrSpec_list != NN
	&& !se_in_parse_ArrayConstructor)
		fatal ("subscript list already specified with attribute DIMENSION/ARRAY");

	if (se_AttrSpec_list != NN) {  /* array declared using AttrSpec */
		root->EntityDecl.opt7 = opt7 = make (OPT_7);
		opt7->opt7.SubscriptList = tree_dup (se_AttrSpec_list);
		opt7->opt7.Lp = &Lp;
		opt7->opt7.Rp = &Rp;
	}

	if (opt7 != NN)
		entry = install_loc (name, TAB_NODE, root);

	if (se_CommonStmt_in) {
		if (se_CommonStmt_blank)
			SET_blank_common (entry);
		else
			SET_named_common (entry);
	}

	if (opt7 != NN && (sublist = opt7->opt7.SubscriptList) != NN) {  /* is ARRAY */
		SET_array (entry);

		if (array_is_assumed_shape (name, sublist)) {
			if (interf_is_argument (entry)) {
				SET_assumed_shape (entry);
				desc_put_in_table (entry);
				array_put_assumed_bounds (name, sublist);
			}
			else {
				sprintf (serr
				, "array '%s': only arguments can be declared assumed-shape arrays"
				, name);
				fatal (serr);
			}
		}

		shape = shape_set_sizes_decl (sublist);
		entry = install_loc (name, TAB_TYP_SHAPE, shape);
                /* BOZKUS */
           if(!IS_aligned(entry))
                entry->local_shape=make_local_shape(entry->typ->shape);
	}

	if (se_DimensionStmt_in || se_CommonStmt_in) {
		decl_check_entry (entry);  /* for the others is in parse_EntityDecl1 */
		return root;
	}

	entry = install_loc (name, TAB_TYP_ETYPE, se_EtypeSpec);

	if (se_AttrSpec_opt) {
		SET_optional (entry);
	}

	if (se_AttrSpec_param) {
		if (IS_parameter (entry)) {
			sprintf (serr, "attribute PARAMETER for '%s' already set", name);
			fatal (serr);
		}
		else {
			SET_parameter (entry);
		}
	}

	if (se_AttrSpec_external) {
		if (IS_external (entry)) {
			sprintf (serr, "attribute EXTERNAL for '%s' already set", name);
			fatal (serr);
		}
		else {
			SET_external (entry);
		}
	}

	if (se_AttrSpec_intrinsic) {
		if (IS_intrinsic (entry)) {
			sprintf (serr, "attribute INTRINSIC for '%s' already set", name);
			fatal (serr);
		}
		else {
			SET_intrinsic (entry);
		}
	}

	if (se_AttrSpec_save) {
		if (IS_save (entry)) {
			sprintf (serr, "attribute SAVE for '%s' already set", name);
			fatal (serr);
		}
		else {
			SET_save (entry);
		}
	}

	if (se_AttrSpec_intent)
		intent_set (entry->name, se_AttrSpec_intent);

	return root; 
}

Node *parse_EntityDecl1 (root)
Node *root;
{
	Node *entity = root->EntityDecl1.EntityDecl;
	Node *charlen = root->EntityDecl1.OptCharLength;
	Node *initexpr = root->EntityDecl1.OptInitializationExpr;
	T_Entry *entry;
	char *name = entity->com.str;
	double value;

	root->com.str = name;
	entry = lookup_loc (name);

	if (charlen != NN && se_EtypeSpec->type != TYP_CHARACTER) {
		sprintf (serr
		, "'%s': character length modifier is permitted only for CHARACTER types"
		, name);
		fatal (serr);  /* E_5_3_2 */
	}

	if (initexpr != NN
	&& (!se_AttrSpec_param || IS_array (entry))  /* deal somewhere else */
	) {
		if (expr_is_constant (initexpr->OptInitializationExpr.Expr, &value)) {
			SET_has_initexpr (entry);
			ENTRY_INITEXPR (entry) = initexpr;
		}
		else {  /* error is flag somewhere else */
			sprintf (serr, "initialization expression for '%s' is a non-constant"
			, name);
			fatal (serr);
		}

		root->EntityDecl1.OptInitializationExpr = NN;
	}

	decl_check_entry (entry);

	return root;
}

/* Adds extra Stmts for some attributes */

Node *parse_TypeDeclarationStmt (root)
Node *root;
{
	Node *cc = root->TypeDeclarationStmt.Colon;
	Node *entitylist = root->TypeDeclarationStmt.EntityDecl1List;

	int i, num, nlist, nlist_orig;
	Node *entity, *temp, *name, *expr, *optexpr;
	Node **list, *stmt, *dumlist;
	T_Entry *entry;
	double value;

	entitylist = list_invert (entitylist);

	num = 0;
	for (LIST_LOOP (entity, entitylist, temp)) 
		num++;

	nlist_orig = num;
	nlist = 2 * num + 1;

	if (se_AttrSpec_external) {
		list = list_alloc (nlist);
		list [0] = &External;

		num = 1;
		for (LIST_LOOP (entity, entitylist, temp)) {
			list [num++] = entity->EntityDecl1.EntityDecl->EntityDecl.Name;
			list [num++] = &Comma;
		}

		list [nlist - 1] = NN;

		dumlist = make_DumList (nlist, list);
		stmt = make_DumStmt (make (EXTERNAL_STMT), dumlist);
		root->com.trans = trans_add_stmt_bef (root->com.trans, stmt);
	}

	if (se_AttrSpec_intrinsic) {
		list = list_alloc (nlist);
		list [0] = &Intrinsic;

		num = 1;
		for (LIST_LOOP (entity, entitylist, temp)) {
			list [num++] = entity->EntityDecl1.EntityDecl->EntityDecl.Name;
			list [num++] = &Comma;
		}

		list [nlist - 1] = NN;

		dumlist = make_DumList (nlist, list);
		stmt = make_DumStmt (make (INTRINSIC_STMT), dumlist);
		root->com.trans = trans_add_stmt_bef (root->com.trans, stmt);
	}

	if (se_AttrSpec_save) {
		list = list_alloc (nlist);
		list [0] = &Save;

		num = 1;
		for (LIST_LOOP (entity, entitylist, temp)) {
			list [num++] = entity->EntityDecl1.EntityDecl->EntityDecl.Name;
			list [num++] = &Comma;
		}

		list [nlist - 1] = NN;

		dumlist = make_DumList (nlist, list);
		stmt = make_DumStmt (make (SAVE_STMT), dumlist);
		root->com.trans = trans_add_stmt_bef (root->com.trans, stmt);
	}

/*
For array parameters, we just don't declare them as PARAMETER and initialize like
normal variables.
*/

	if (se_AttrSpec_param
	&& se_AttrSpec_list == NN) {
		T_Entry *entry_par;

		nlist = 3 + nlist_orig * 3;
		list = list_alloc (nlist);
		list [0] = &Parameter;
		list [1] = &Lp;

		num = 2;
		for (LIST_LOOP (entity, entitylist, temp)) {
			optexpr = entity->EntityDecl1.OptInitializationExpr;
			entity->EntityDecl1.OptInitializationExpr = NN;

			if (entity->EntityDecl1.EntityDecl->EntityDecl.opt7!= NN)
				continue;

			name = entity->EntityDecl1.EntityDecl->EntityDecl.Name;
			if (optexpr == NN) {
				sprintf (serr
				, "initialization expression for '%s' is required", name->com.str);
				fatal (serr);  /* E_5_2_44 */
				continue;
			}

			expr = optexpr->OptInitializationExpr.Expr;
			entry_par = lookup_loc (name->com.str);
			ENTRY_VALUE (entry_par) = expr;

			if (expr_is_constant (expr, &value) == 0) {
				sprintf (serr, "PARAMETER '%s' set to a non-constant", name->com.str);
				fatal (serr);
			}

			list [num++] = name;
			list [num++] = optexpr;
			list [num++] = &Comma;
		}

		list [num - 1] = &Rp;

		if (num > 2) {
			dumlist = make_DumList (nlist, list);
			stmt = make_DumStmt (make (PARAMETER_STMT), dumlist);
			root->com.trans = trans_add_stmt_aft (root->com.trans, stmt);
		}
	}

	for (LIST_LOOP (entity, entitylist, temp)) {
		entry = lookup_loc (entity->com.str);

		if (IS_has_initexpr (entry) && cc == NN) {
			fatal (
			"presence of initialization expression requires '::'");  /* E_5_2_44 */
			break;
		}
	}

	return root;
}

Node *parse_SubroutineStmt (root)
Node *root;
{
	Node *Nname = root->SubroutineStmt.Name;
	Node *arglist = root->SubroutineStmt.OptDummyArgList;

	char *name = Nname->com.str;
	T_Entry *entry;

	if (state_level == 0)  /* so that it is not done inside contained INTERFACEs */
		interf_old_entry = lookup_user (name);

	if (!se_in_interface
	&&  (entry = lookup_user (name)) != TN
	&&	!IS_intrinsic (entry)  /* it is OK to redefine intrinsics */
	) {
		if (IS_defined_proc (entry)) {
			sprintf (serr, "redefinition of procedure '%s'", name);
			fatal (serr);
		}
	}
	
	entry = install_glo (name, TAB_NODE, root);
	SET_subroutine (entry);

	if (!se_in_interface)
		SET_defined_proc (entry);

	interf_begin (name, arglist);

	return root;
}

Node *parse_FunctionStmt (root)
Node *root;
{
	Node *opt31 = root->FunctionStmt.opt31;
	Node *Nname = root->FunctionStmt.Name;
	Node *optnamelist = root->FunctionStmt.OptNameList;
	Node *opt33 = root->FunctionStmt.opt33;

	char *name = Nname->com.str;
	Etype *etype;
	T_Entry *entry;

	if (state_level == 0)  /* so that it is not done inside contained INTERFACEs */
		interf_old_entry = lookup_user (name);

    if (!se_in_interface
	&&  (entry = lookup_user (name)) != TN
	&&	!IS_intrinsic (entry)  /* it is OK to redefine intrinsics */
	) {
        if (IS_defined_proc (entry)) {
            sprintf (serr, "redefinition of procedure '%s'", name);
            fatal (serr);
        }
    }

	se_FunctionStmt_name = name;
	se_FunctionStmt_etype = se_EtypeSpec;

	interf_begin (name, optnamelist);
	
	return root;
}

Node *parse_AssignementStmt (root)
Node *root;
{
	Shape *shape;
	Node *var = root->AssignementStmt.Variable;
	Node *expr = root->AssignementStmt.Expr;
	static int call_once = 1;
	Node *array;
	char *name = var->com.str;
	T_Entry *entry = lookup_loc (name);

	if (var->com.type == FUNCTION_REFERENCE
	&& var->com.typ->etype->type != TYP_CHARACTER) { /*do: character*3 string (4)*/
		int rank_decl = 0, rank_var, rank_shape_var;
		double value;

		rank_var = tree_list_len (var->FunctionReference.SubscriptList);
		rank_shape_var = RANK_FROM_SHAPE (var->com.typ->shape);
		
		if (entry != TN)
			rank_decl = RANK_FROM_SHAPE (entry->typ->shape);
        typ_store_index_forall(root);
		if (state [state_level] < STATE_EXEC
		&& rank_decl == 0
		&& rank_shape_var == 0) { /* sta fun-def */
			if (rank_var
			&& expr_is_constant (var->FunctionReference.SubscriptList, &value))
				fatal ("argument in statement function definition is constant");

			se_is_statement_function_def = 1;
			root->com.type = STMT_FUNCTION_STMT;
		}
		else if (entry == TN || rank_decl == 0) {
			sprintf (serr, "'%s' is not an ARRAY", name);
			fatal (serr);
		}
	}

	if (entry) {
		if (IS_parameter (entry) && !se_in_decl_initexpr_parse) {
			sprintf (serr, "trying to set PARAMETER '%s'", entry->orig_name);
			fatal (serr);
		}
	}

	if (var->com.typ == (Typ*) 0)
		printf ("here\n");


	root->com.typ = typ_expr (var, &Eq, expr);
        /** BOZKUS **/
/*       if(root->com.typ->shape) distribute_loop(root); */
        /** END **/
	if ((shape = root->com.typ->shape) != (Shape*) 0) {

#ifdef CUBIX
		fatal ("array expression");
#endif

		array_num_index_set (root->com.typ->shape->rank);
        npac_rank=root->com.typ->shape->rank;
        npac_temp1=npac_rank;
		fun_out_of_assig (root);
 npac_loop= RANK_FROM_SHAPE(root->AssignementStmt.Variable->com.typ->shape);
npac_loop2[parse_check]=npac_loop;
parse_check++;

		if (expr->com.typ->shape != (Shape*) 0 && call_once
		&& se_in_ForallStmt == 0) {

/* ##BEG##, 11/12/91, ZEKI */
/*
 This partd is changed when there are same variable lhs and rhs
 it will not change it becacuse forall loop semantic will
 not be effected eventough DO loop semantic is
*/
/*
			if (misc_var_is_in_both (var, expr)) {
				call_once = 0;
				root->AssignementStmt.Expr = temp_replace (expr);
				call_once = 1;
			}
*/
		}
	}
/* ##BEGIN##, 2/19/92,  ZEKI */
/*
 This is to cat an automatic array and replace its shape with left hand side shape
        remember that automatic array is created for intrinsic outout
*/
        find_output_of_intrinsic(expr,var);
/* ##END##, 2/19/92,  ZEKI */
 /* BOZKUS */


/*      if(root->com.typ->shape!=SN){
          if(root->com.typ->shape->rank>0)
                 root = transfer_to_forall(root); 
	}*/
     /* else   root=mask(root);*/
        root=comm_AssignementStmt(root);
	return root;
}

Node *parse_IntrinsicStmt (root)
Node *root;
{
	Node *namelist = root->IntrinsicStmt.NameList;
	Node *name, *temp;
	T_Entry *entry;
	Etype *etype;

	for (LIST_LOOP (name, namelist, temp)) {  /*!!! just temporary fix */
		if ((entry = lookup_loc (name->com.str)) == TN) {
			etype = implicit_get (name->com.str);
			entry = install_loc (name->com.str, TAB_TYP_ETYPE, etype);
			SET_implicit_type (entry);
		}

		SET_intrinsic (entry);
	}

	return root;
}

Node *parse_ExternalStmt (root)
Node *root;
{
	Node *namelist = root->ExternalStmt.NameList;
	Node *name, *temp;
	T_Entry *entry;
	Etype *etype;

	for (LIST_LOOP (name, namelist, temp)) {  /*!!! just temporary fix */
		if ((entry = lookup_loc (name->com.str)) == TN) {
			etype = implicit_get (name->com.str);
			entry = install_loc (name->com.str, TAB_TYP_ETYPE, etype);
			SET_implicit_type (entry);
		}

		SET_external (entry);
	}

	return root;
}

Node *parse_DumExpr (root)
Node *root;
{
	double value;

	struct S_DumExpr *expr = &root->DumExpr;

	root->com.typ = typ_expr (expr->Expr, expr->Op, expr->Expr1);

/* replaces 5/0 by temp = 0; 5/temp so that f77 compiler doesn't blow up */

	if (expr->Op->com.type == SLASH)
		if (expr->Expr1->com.typ->etype->type == TYP_INTEGER
		&& expr_is_constant (expr->Expr1, &value)
		&& U_nint (value) == 0) {
			expr->Expr1 = temp_replace (expr->Expr1);
			warning ("found divide by zero while evaluating constant expression");
		}

#ifdef CANNOT_HANDLE_INT_TO_NEG
	if (state [state_level] > STATE_DECL && expr->Op->com.type == POWER_OP)
		if (expr_is_constant (expr->Expr1, &value)
		&& U_nint (value) < 0)
			expr->Expr1 = temp_replace (expr->Expr1);
#endif

	return root;
}

int misc_var_is_in_both (var, expr)
Node *var, *expr;
{
	char *varname;

	switch (var->com.type) {

	case ARRAY_SECTION:
		varname = var->ArraySection.Name->com.str;
		return misc_is_name_in_tree (varname, expr);
		break;

	case NAME:
		varname = var->com.str;
		return misc_is_name_in_tree (varname, expr);
		break;

	default: /*!!! SYSERR? */
		return 1;
	}
}

int misc_is_name_in_tree (name, tree)
char *name;
Node *tree;
{
	int i;
	Node *child;

	if (tree == NN)
		return 0;

	for (i = 0; i < node_nodes (tree->com.type); i++) {
		if ((child = tree->com.node [i]) != NN && child->com.type == NAME) {
			if (!U_strcmp_nocase (name, child->com.str))
				return 1;
		}
		if (misc_is_name_in_tree (name, child))
			return 1;
	}

	return 0;
}


